/*
 * FB Chat Sidebar Disabler - Firefox XUL JS loader
 * Copyright (C) 2011 VittGam.net. All rights reserved.
 *
 * This work is licensed under a Creative Commons
 * Attribution-NonCommercial-NoDerivs 3.0 Unported License
 * http://creativecommons.org/licenses/by-nc-nd/3.0/
 *
 * UNLESS OTHERWISE MUTUALLY AGREED BY THE PARTIES IN WRITING,
 * LICENSOR OFFERS THE WORK AS-IS AND MAKES NO REPRESENTATIONS
 * OR WARRANTIES OF ANY KIND CONCERNING THE WORK, EXPRESS, IMPLIED,
 * STATUTORY OR OTHERWISE, INCLUDING, WITHOUT LIMITATION, WARRANTIES
 * OF TITLE, MERCHANTIBILITY, FITNESS FOR A PARTICULAR PURPOSE,
 * NONINFRINGEMENT, OR THE ABSENCE OF LATENT OR OTHER DEFECTS,
 * ACCURACY, OR THE PRESENCE OF ABSENCE OF ERRORS, WHETHER OR NOT
 * DISCOVERABLE. SOME JURISDICTIONS DO NOT ALLOW THE EXCLUSION OF
 * IMPLIED WARRANTIES, SO SUCH EXCLUSION MAY NOT APPLY TO YOU.
 * EXCEPT TO THE EXTENT REQUIRED BY APPLICABLE LAW, IN NO EVENT
 * WILL LICENSOR BE LIABLE TO YOU ON ANY LEGAL THEORY FOR ANY SPECIAL,
 * INCIDENTAL, CONSEQUENTIAL, PUNITIVE OR EXEMPLARY DAMAGES ARISING
 * OUT OF THIS LICENSE OR THE USE OF THE WORK, EVEN IF LICENSOR HAS
 * BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
 */

(function(){
	var getUrlContents=function(aUrl){
		var ioService=Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
		var scriptableStream=Components.classes["@mozilla.org/scriptableinputstream;1"].getService(Components.interfaces.nsIScriptableInputStream);
		var unicodeConverter=Components.classes["@mozilla.org/intl/scriptableunicodeconverter"].createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
		unicodeConverter.charset="UTF-8";
		var channel=ioService.newChannel(aUrl,"UTF-8",null);
		var input=channel.open();
		scriptableStream.init(input);
		var str=scriptableStream.read(input.available());
		scriptableStream.close();
		input.close();
		try {
			return unicodeConverter.ConvertToUnicode(str);
		} catch (e) {
			return str;
		}
	};
	var contentload=function(e){
		var unsafeWin=e.target.defaultView;
		if (unsafeWin.wrappedJSObject) {
			unsafeWin=unsafeWin.wrappedJSObject;
		}
		var href=new XPCNativeWrapper(new XPCNativeWrapper(unsafeWin,"location").location,"href").href.toString();
		var scheme=Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService).extractScheme(href);
		var pref=Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("fbsidebardisabler.");
		var getItem2=function(prefName){
			var prefType=pref.getPrefType(prefName);
			if (prefType==pref.PREF_INVALID) {
				return null;
			}
			switch (prefType) {
				case pref.PREF_STRING:
					return pref.getCharPref(prefName);
				case pref.PREF_BOOL:
					return pref.getBoolPref(prefName);
				case pref.PREF_INT:
					return pref.getIntPref(prefName);
			}
		};
		var setItem2=function(prefName,value){
			var prefType=typeof value;
			switch (prefType) {
				case "string":
				case "boolean":
					break;
				case "number":
					if ((value%1)!=0) {
						return false;
					}
					break;
				default:
					return false;
			}
			if (pref.getPrefType(prefName)!=0 && prefType!=typeof(getItem2(prefName))) {
				pref.deleteBranch(prefName);
			}
			switch (prefType) {
				case "string":
					pref.setCharPref(prefName,value);
					break;
				case "boolean":
					pref.setBoolPref(prefName,value);
					break;
				case "number":
					pref.setIntPref(prefName,Math.floor(value));
					break;
			}
		};
		var localstore={
			/*
			 * Cross-browser compatibility with Chrome
			 */
			getItem:function(itemName,callback){
				try {
					callback(getItem2(itemName));
					return;
				} catch (e) {}
				callback(null);
			},
			setItem:function(itemName,itemValue){
				try {
					setItem2(itemName,itemValue);
				} catch (e) {}
			},
			is_fbsidebardisabler_localstore:true
		};
		if (getItem2('welcome_shown')!=true) {
			setItem2('welcome_shown',true);
			gBrowser.selectedTab=gBrowser.addTab('http://www.sidebardisabler.net/#welcome');
		}
		if (((scheme=="http") || (scheme=="https") || (scheme=="file")) && !(/hiddenWindow\.html$/.test(href)) && (/^.*:\/\/.*\.facebook\.com\/.*$/.test(href))) {
			/*
			 * This is needed for cross-browser compatibility of the same
			 * main script, and is deleted immediately from unsafeWin by
			 * the main script
			 */
			unsafeWin.fbsidebardisabler_localstore=localstore;
			var scriptcontents=getUrlContents('resource://fbsidebardisabler/fbsidebardisabler.js');
			var tempscript=unsafeWin.document.createElement('script');
			tempscript.appendChild(unsafeWin.document.createTextNode('(function(){'+scriptcontents+'})();'));
			(unsafeWin.document.body||unsafeWin.document.head||unsafeWin.document.documentElement).appendChild(tempscript);
		}
	};
	var onload=function(){
		window.document.getElementById("appcontent").addEventListener("DOMContentLoaded",contentload,false);
	};
	var onunload=function(){
		window.removeEventListener('load',onload,false);
		window.removeEventListener('unload',onunload,false);
		window.document.getElementById("appcontent").removeEventListener("DOMContentLoaded",contentload,false);
	};
	window.addEventListener('load',onload,false);
	window.addEventListener('unload',onunload,false);
})();

